#include <math.h>
#include <stdio.h>

static double shiftx = 0.8, shifty = 0.65, scale = 0.6, dist = 8.0;
static double ct = 1., st = 0., cg = 1., sg = 0., cr = 1., sr = 0.;
static double dgr = 3.14159/180.0;

int rotat(double);
int triplt(double, double, double, double*, double*);

int setProjection()
{
  double theta = 30.0, gamma = 45.0;
  double x1,x2,y1,y2,r;
  ct = cos(theta*dgr);
  st = sin(theta*dgr);
  cg = cos(gamma*dgr);
  sg = sin(gamma*dgr);
  cr = 1.0; sr = 0.0;
  triplt(0.0, 0.0, 0.0, &x1, &y1);
  triplt(0.0, 1.0, 0.0, &x2, &y2);
  r = atan((x2-x1)/(y2-y1))/dgr;
  rotat(r);
  return 1;
}

int rotat(double rho)
{
    cr = cos(rho*dgr);
    sr = sin(rho*dgr);
    return 0;
}

int triplt(double x, double y, double z, double *spx, double *spy)
{
    double d, px, py, pz;
    px = y*st + x*ct;
    py = y*ct - x*st;
    pz = px*sg + z*cg;
    px = px*cg - z*sg;
    d = dist/(dist - pz);
    px *= d;
    py *= d;
    d = cr*px - sr*py;
    *spy = (shifty + sr*px + cr*py)*scale;
    *spx = (shiftx + d)*scale;
    return 0;
} 

